"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AwsShapes = void 0;

var _AwsParam = require("./AwsParam");

class AwsShapes {
  constructor(shapes, prefix) {
    this.shapes = shapes;
    this.prefix = prefix;
    this.shapesInput = {};
    this.shapesOutput = {};
  }

  getInputShape(name) {
    if (!this.shapesInput[name]) {
      if (!this.shapes[name]) {
        throw new Error(`Shape with name '${name}' not found in service config ${this.prefix}`);
      } // store firstly as JSON, for solving recursion calls


      this.shapesInput[name] = 'JSON';
      this.shapesInput[name] = _AwsParam.AwsParam.convertParam(this.shapes[name], `${this.prefix}${name}`, true, this);
    }

    return this.shapesInput[name];
  }

  getOutputShape(name) {
    if (!this.shapesOutput[name]) {
      if (!this.shapes[name]) {
        throw new Error(`Shape with name '${name}' not found in service config ${this.prefix}`);
      } // store firstly as JSON, for solving recursion calls


      this.shapesOutput[name] = 'JSON';
      this.shapesOutput[name] = _AwsParam.AwsParam.convertParam(this.shapes[name], `${this.prefix}${name}`, false, this);
    }

    return this.shapesOutput[name];
  }

}

exports.AwsShapes = AwsShapes;