"use strict";

var _graphqlCompose = require("graphql-compose");

var _AwsServiceMetadata = require("../AwsServiceMetadata");

var _s = _interopRequireDefault(require("../__mocks__/s3-2006-03-01.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = new _AwsServiceMetadata.AwsServiceMetadata(_s.default.metadata);
describe('AwsServiceMetadata', () => {
  it('getPrefix()', () => {
    expect(meta.getPrefix()).toBe('AwsS3');
  });
  it('getTypeComposer()', () => {
    const tc = meta.getTypeComposer();
    expect(tc).toBeInstanceOf(_graphqlCompose.ObjectTypeComposer);
    expect(tc.getTypeName()).toBe('AwsS3Metadata');
    expect(tc.getFieldNames()).toMatchSnapshot();
  });
  it('getFieldConfig()', () => {
    const fc = meta.getFieldConfig();
    expect(fc).toMatchSnapshot();
    expect(fc.resolve()).toMatchSnapshot();
  });
});