"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTypeName = getTypeName;
exports.getOrSetType = getOrSetType;
exports.desc = desc;

var _graphqlCompose = require("graphql-compose");

const typeStorage = new _graphqlCompose.TypeStorage();

function getTypeName(name, opts) {
  return `${opts && opts.prefix || 'Elastic'}${name}${opts && opts.postfix || ''}`;
}

function getOrSetType(typeName, typeOrThunk) {
  const type = typeStorage.getOrSet(typeName, typeOrThunk);
  return type;
} // Remove newline multiline in descriptions


function desc(str) {
  return str.replace(/\n\s+/gi, ' ').replace(/^\s+/, '');
}