function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { schemaComposer, ObjectTypeComposer, upperFirst } from 'graphql-compose';
export class AwsServiceMetadata {
  constructor(metadata) {
    this.metadata = metadata;
  }

  getPrefix() {
    return `Aws${upperFirst(this.metadata.endpointPrefix)}`;
  }

  getDescription() {
    // { apiVersion: '2006-03-01',
    //   checksumFormat: 'md5',
    //   endpointPrefix: 's3',
    //
    //   globalEndpoint: 's3.amazonaws.com',
    //   protocol: 'rest-xml',
    //   serviceAbbreviation: 'Amazon S3',
    //   serviceFullName: 'Amazon Simple Storage Service',
    //   serviceId: 'S3',
    //   signatureVersion: 's3',
    //   timestampFormat: 'rfc822',
    //   uid: 's3-2006-03-01' }
    const {
      serviceFullName,
      apiVersion
    } = this.metadata;
    return `${serviceFullName} (${apiVersion})`;
  }

  getTypeComposer() {
    if (!this.tc) {
      this.tc = schemaComposer.createObjectTC(`
        type ${this.getPrefix()}Metadata {
          apiVersion: String
          endpointPrefix: String
          globalEndpoint: String
          serviceAbbreviation: String
          serviceFullName: String
          signatureVersion: String
          uid: String
          raw: JSON
        }
      `);
    }

    return this.tc;
  }

  getFieldConfig() {
    return {
      type: this.getTypeComposer().getType(),
      resolve: () => {
        return _objectSpread({}, this.metadata, {
          raw: this.metadata
        });
      }
    };
  }

}